/*
 * Assembly Language Debugger
 *
 * Copyright (C) 2000 Patrick Alken
 * This program comes with absolutely NO WARRANTY
 *
 * Should you choose to use and/or modify this source code, please
 * do so under the terms of the GNU General Public License under which
 * this program is distributed.
 *
 * $Id: load.h,v 1.1.1.1 2000/09/11 17:23:54 cosine Exp $
 */

#ifndef INCLUDED_load_h
#define INCLUDED_load_h

#ifndef INCLUDED_stdio_h
#include <stdio.h>            /* FILE* */
#define INCLUDED_stdio_h
#endif

#ifndef INCLUDED_sys_types_h
#include <sys/types.h>        /* size_t */
#define INCLUDED_sys_types_h
#endif

/*
 * Object types
 */

#define OT_UNKNOWN  1  /* unknown object format */
#define OT_ELF      2  /* Executable and Linkable Format (ELF) */
#define OT_AOUT     3  /* a.out format */

/*
 * Prototypes
 */

int LoadFile(char *filename);
void UnloadFile(char *filename);

/*
 * External declarations
 */

extern void           *MapPtr;
extern size_t         MappedSize;
extern int            ObjectFileDescriptor;
extern char           *ObjectFileName;
extern int            ObjectFileFormat;
extern unsigned int   ObjectFileOffset;
extern unsigned int   EntryPoint;
extern unsigned int   VirtualFileAddress;
extern unsigned int   VirtualEntryPoint;
extern unsigned int   VirtualObjectFileOffset;
 
#endif /* INCLUDED_load_h */
